HDU 4337 King Arthur's Knights (图论+dfs) = =

来源:互联网 发布:河南师范大学教务网络 编辑:程序博客网 时间:2024/04/28 08:01

King Arthur's Knights

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 1518 Accepted Submission(s): 645
Special Judge


Problem Description
I am the bone of my sword. Steel is my body, and the fire is my blood.
- from Fate / Stay Night
You must have known the legend of King Arthur and his knights of the round table. The round table has no head, implying that everyone has equal status. Some knights are close friends with each other, so they prefer to sit next to each other.

Given the relationship of these knights, the King Arthur request you to find an arrangement such that, for every knight, his two adjacent knights are both his close friends. And you should note that because the knights are very united, everyone has at least half of the group as his close friends. More specifically speaking, if there are N knights in total, every knight has at least (N + 1) / 2 other knights as his close friends.

Input
The first line of each test case contains two integers N (3 <= N <= 150) and M, indicating that there are N knights and M relationships in total. Then M lines followed, each of which contains two integers ai and bi (1 <= ai, bi <= n, ai != bi), indicating that knight ai and knight bi are close friends.

Output
For each test case, output one line containing N integers X1, X2, ..., XN separated by spaces, which indicating an round table arrangement. Please note that XN and X1 are also considered adjacent. The answer may be not unique, and any correct answer will be OK. If there is no solution exists, just output "no solution".

Sample Input
3 31 22 31 34 41 42 42 31 3

Sample Output
1 2 31 4 2 3

Source
2012 Multi-University Training Contest 4

Recommend
zhoujiaqi2010

题意:一个圆桌,安排座位。每个人的左右都要是自己的朋友。已知每个人都有一半以上的人是他的朋友。这个题应该用哈密顿回路做的,但是那个前提使得不
            可能无解,所以带回溯的深搜可以过,这样就变成和经典素数环一样的了。
感想:
1、首先建图是无向图啊,同学!!!开始就是这里没注意啊喂。要re[a][b]=true,re[b][a]=true;
2、你居然漏打!=EOF,不超时才怪。。。。难怪比完赛下来搜解题报告除了下标起始位置不同,几乎一摸一样你的过不了啊。。。。

代码:
#include<iostream>#include<cmath>#include<cstdio>#include<vector>#include<cstring>#include<algorithm>using namespace std;bool re[155][155];int ok[155];bool vis[155];int n,m;int flag;void dfs(int a,int pos){    if(flag==1)        return;    if(pos==n+1)    {        if(re[ok[1]][ok[n]])        {            for(int i=1;i<=n;i++)                printf("%d%c",ok[i],i==n?'\n':' ');            flag=1;        }    }    else    {        for(int i=2;i<=n;i++)        {            if(re[a][i]&&!vis[i])            {                vis[i]=true;                ok[pos]=i;                //printf("test: %d %d\n",pos,i);                dfs(i,pos+1);                //if(flag==1)                    //break;                vis[i]=false;            }        }    }}int main(){    int a,b;    while(scanf("%d%d",&n,&m)!=EOF)    {        memset(vis,0,sizeof(vis));        memset(re,0,sizeof(re));        memset(ok,0,sizeof(ok));        flag=0;        for(int i=1;i<=m;i++)        {            scanf("%d%d",&a,&b);            re[a][b]=true;            re[b][a]=true;        }        ok[1]=1;        dfs(1,2);        if(!flag)            printf("no solution\n");    }    return 0;}

8870377

2013-08-08 10:41:14

Accepted

4337

31MS

252K

1272 B

C++



另一个回溯到主函数再输出结果的代码:
#include<iostream>#include<cmath>#include<cstdio>#include<vector>#include<cstring>#include<algorithm>using namespace std;bool re[155][155];int ok[155];bool vis[155];int n,m;int flag;void dfs(int a,int pos){    if(flag==1)        return;    if(pos==n+1)    {        if(re[ok[1]][ok[n]])            flag=1;        //return;    }    else    {        for(int i=2;i<=n;i++)        {            if(re[a][i]&&!vis[i]&&flag==0)            {                vis[i]=true;                ok[pos]=i;                //printf("test: %d %d\n",pos,i);                dfs(i,pos+1);                //if(flag==1)                   //break;                vis[i]=false;            }        }           }}int main(){    int a,b;    while(scanf("%d%d",&n,&m)!=EOF)    {        memset(vis,0,sizeof(vis));        memset(re,0,sizeof(re));        memset(ok,0,sizeof(ok));        flag=0;        for(int i=1;i<=m;i++)        {            scanf("%d%d",&a,&b);            re[a][b]=true;            re[b][a]=true;        }        ok[1]=1;        dfs(1,2);        if(flag)        {            for(int i=1;i<=n;i++)                printf("%d%c",ok[i],i==n?'\n':' ');        }        else printf("no solution\n");    }    return 0;}

8872033

2013-08-08 13:20:07

Accepted

4337

31MS

252K

1198 B

C++



原创粉丝点击